<?php
if (!defined('ABSPATH')) die;

class buzzblogpro_snapchat_snapcode extends WP_Widget {

	protected $defaults;

	function __construct() {

		$this->defaults = array(
			'title' => '',
			'snapcode' => '',
			'snapchat_account' => '',
		);

		$widget_ops = array(
			'classname' => 'buzzblogpro_snapchat_snapcode',
			'description' => __('Display your Snapchat Snapcode.', 'buzzblogpro'),
		);

		$control_ops = array(
			'id_base' => 'buzzblogpro_snapchat_snapcode',
			'width'   => 200,
			'height'  => 250,
		);

		parent::__construct('buzzblogpro_snapchat_snapcode', 'Hercules - Snapchat Snapcode', $widget_ops, $control_ops);

	}

	// The widget content.
	function widget($args, $instance) {

		//* Merge with defaults
		$instance = wp_parse_args((array) $instance, $this->defaults);

		echo $args['before_widget'];
		
			$greyscale = '';
			if (!empty($instance['greyscale'])) {
				$greyscale = 'style="-webkit-filter: grayscale(100%); filter: grayscale(100%);"';
			}

			if (! empty($instance['title']))
				echo $args['before_title'] . apply_filters('widget_title', $instance['title'], $instance, $this->id_base) . $args['after_title'];
			
			$link_open = $link_close = '';
			if (!empty($instance['snapchat_account'])) {
				$link_open = '<a href="'.esc_url('https://www.snapchat.com/add/'.trim($instance['snapchat_account'])).'" target="_blank" rel="nofollow noopener">';
				$link_close = '</a>';
			}

			if (!empty($instance['snapcode'])) {
				$image_link = str_replace('http:', '', $instance['snapcode']);
				
				$lazy_class = '';
				$bool = buzzblogpro_getVariable('lazyload_images');
						if ( $bool == 'yes') {
					$lazy_class = 'class="lazyload"';
					$image_src = 'data-src="'.esc_url($image_link).'"';
				} else {
					$image_src = 'src="'.esc_url($image_link).'"';
				}
				
				echo $link_open.'<img '.$image_src.' alt="Snapchat" '.$lazy_class.' data-pin-nopin="true" '.$greyscale.' />'.$link_close;
				if (!empty($instance['snapchat_account'])) {
					echo '<span>'.sprintf( __('Follow <strong>%s</strong> on Snapchat!', 'buzzblogpro'), strip_tags($instance['snapchat_account']) ).'</span>';
				}
			}
			
		echo $args['after_widget'];

	}

	// Update a particular instance.
	function update($new_instance, $old_instance) {

		$new_instance['title'] = strip_tags($new_instance['title']);
		$new_instance['snapcode'] = strip_tags($new_instance['snapcode']);
		$new_instance['snapchat_account'] = strip_tags($new_instance['snapchat_account']);
		$new_instance['greyscale'] = strip_tags($new_instance['greyscale']);

		return $new_instance;

	}

	// The settings update form.
	function form($instance) {

		// Merge with defaults
		$instance = wp_parse_args((array) $instance, $this->defaults);
		
		$greyscale = '';
		if (!empty($instance['greyscale'])) {
			$greyscale = '-webkit-filter: grayscale(100%); filter: grayscale(100%);';
		}

		?>
		<p>
			<label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:'); ?></label>
			<input type="text" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" value="<?php if (isset($instance['title'])) echo esc_attr($instance['title']); ?>" class="widefat" />
		</p>
		
		<p>1. Download your Snapcode PNG image from <a href="https://accounts.snapchat.com/accounts/snapcodes?type=png" target="_blank">this link</a></p>
		<p>2. Upload your Snapcode PNG image using the button below.</p>

		<p>
				<input type="text" id="<?php echo $this->get_field_id('snapcode'); ?>" name="<?php echo $this->get_field_name('snapcode'); ?>" value="<?php echo esc_attr($instance['snapcode']); ?>" style="display: none" />
				<input type="button" onClick="hs_open_uploader(this, 'baner_image')" value="<?php echo esc_attr(__('Select Image', 'buzzblogpro')); ?>" class="button" id="<?php echo $this->get_field_id('snapcode'); ?>-button" />
				<span class="baner_image" style="text-align:center;"><?php $img_style = ($instance[ 'snapcode' ] != '') ? 'display:block;' : 'display:none;'; ?>
					<img id="<?php echo $this->get_field_id('snapcode'); ?>-preview" src="<?php echo esc_attr($instance['snapcode']); ?>" style="padding:8px;max-width:180px!important;height:auto;<?php echo $img_style.$greyscale; ?>" />
					<?php $no_img_style = ($instance[ 'snapcode' ] != '') ? 'style="display:none;"' : ''; ?></span>
		</p>
		
		<p>
			<label for="<?php echo $this->get_field_id('snapchat_account'); ?>"><?php _e('Snapchat Account Name:', 'buzzblogpro'); ?></label>
			<input type="text" id="<?php echo $this->get_field_id('snapchat_account'); ?>" name="<?php echo $this->get_field_name('snapchat_account'); ?>" value="<?php if (isset($instance['snapchat_account'])) echo esc_attr($instance['snapchat_account']); ?>" class="widefat" placeholder="<?php _e("For example:", 'buzzblogpro'); ?> hercules" />
		</p>
		
		<p>
			<label for="<?php echo $this->get_field_id('greyscale'); ?>">
			<input type="checkbox" id="<?php echo $this->get_field_id('greyscale'); ?>" name="<?php echo $this->get_field_name('greyscale'); ?>" <?php if (isset($instance['greyscale'])) { checked( (bool) $instance['greyscale'], true ); } ?> /><?php _e('Display in grayscale', 'buzzblogpro'); ?></label>
			<br />
		</p>

		<?php

	}

}
if(!function_exists('buzzblogpro_upload_enq')){
	function buzzblogpro_upload_enq($hook){
	if( $hook != 'widgets.php' )
	return;
	
wp_enqueue_media(); 	
	  wp_enqueue_script('buzzblogpro-hsenq', plugin_dir_url(__FILE__) . 'aboutme-js/admin-script.js', array('jquery'), null, true);
	}
	add_action('admin_enqueue_scripts', 'buzzblogpro_upload_enq');
}